$ ===========================================================================
$ [...\ENDLG\INCLUDE\ENUSRTAB.INC]
$ e-norm-Dialog         : Include-Datei zur Erzeugung von USER-Tabellen
$                         in ENORMUSR.MDB
$
$ Autor                 : P. Locarek, P. Locarek SOFTWARETECHNIK
$ Copyright             : P. Locarek SOFTWARETECHNIK
$ Datum der Erstellung  :
$ letzte nderung       :
$ Rev.:                 : 9.000
$ ===========================================================================

$ =====================================================================================================================
$ Entspricht Function CheckTables
$
$ Tabellen prfen
$ =====================================================================================================================

ATTRIBUTES = PARENTHESIS
if (TAB.TABNAME <> '')
   {
   TABCREATE_OK         = 1
   Auto_Insert_Record   = 1

   if not (SQL(2; '#TABEXIST %TAB.TABNAME'; UDSN))
      {
      TABELLSCHONDA = 0
      warning
         {
         "~a077f Tabelle existiert noch nicht in USER-Datenbank!"
         "~a01bf Tabelle"+': <'+TAB.TABNAME+'>  '+"~a0780 in Datasource"+': <'+UDSN+'>'
         "~a0781 Tabelle wird jetzt angelegt!"
         }


      $ Tabelle erzeugen...
      IOR=SQL(2; '#CREATETAB %TAB.TABNAME  @:odbcds\Admin\EnormUsr.dbd'; UDSN)
      SQL.ERRSTR=SQLERROR()
      if (SQL.ERRSTR <> '@OK@')
         {
         TABCREATE_OK = 0
         error
            {
            if EN.SQLMSG
               {
               'SQL-Error: '+SQL.ERRSTR
               }
            "~a0782 Tabelle konnte nicht erzeugt werden!"
            "~a0783 Prfen Sie bitte ihre ODBC Verbindungen und stellen sie sicher, dass die"
            "~a0784 Datenbank nicht durch einen Zugriff eines anderen Benutzers gesperrt ist!"
            }
         else
            {
            TABELLSCHONDA = 1    $ anscheinend konnte die Tabelle korrekt angelegt werden...
            }
         }
      else
         {
         TABELLSCHONDA = 1       $ Tabelle war schon da
         }
      }

   $ wenn Tabelle existiert, Tabellenkonsistenz prfen (Anzahl der Datenstze)
   if TABELLSCHONDA
      {

      $ Anzahl der Datenstze in Tabelle 1 feststellen...
      IOR=SQL(1; 'SELECT COUNT(*) AS RECANZ1 FROM %TAB.TABNAME'; DSN)

      $ Anzahl der Datenstze in Tabelle 2 feststellen...
      IOR=SQL(2; 'SELECT COUNT(*) AS RECANZ2 FROM %TAB.TABNAME'; UDSN)

      if (RECANZ1 <> RECANZ2)
         {
         if (RECANZ1 > RECANZ2)
            {

            Z = (RECANZ1-RECANZ2)
            K = 0    $ Zhler fr RUNNING zurcksetzen

            if not Auto_Insert_Record
               {
               warning  "~a0785 Tabellen inkonsistent!"
                  {
                  "~a0786 Die Systemtabelle enthlt mehr Datenstze als die USER-Tabelle!"
                  "~a0787 Die USER-Tabelle wird jetzt erweitert!"
                  "~a0788 Anzahl der einzufgenden Datenstze"+': '+Z
                  }
               }

            =RUNNING('Schreibe Daten';Z-1)

            TAB.PARTNR = ' '
            TAB.WEIGHT = 0
            TAB.INFO1  = ' '
            TAB.INFO2  = ' '
            TAB.INFO3  = ' '

            MAXKEY = 0
            $ Grssten Zhler aus der 2. Tabelle (USER) ermitteln...
            IOR1=SQL(2; 'SELECT Max(SKEY) AS MAXKEY FROM %TAB.TABNAME'; UDSN)
            SQL.ERRSTR=SQLERROR()

            $ ...und nach grsseren Schlsseln in der System-Datenbank suchen...
            IOR1=SQL(1; 'SELECT * FROM %TAB.TABNAME WHERE (SKEY > %MAXKEY)'; DSN; 'TAB')
            if IOR1
               {
               TAB.SKEY   = TAB.SKEY    $ Schlssel der 2. Tabelle umschreiben (SKEY --> SKEY)
               }

            $ jetzt sollten die neuen Datenstze im RecordSet stehen. Diese knnen jetzt mit der
            $ #NEXT - Anweisung durchsucht werden...

            While (IOR1)   $ so lange noch ein Datensatz im RecordSet gefunden wird...
               {
               $ ...Daten in 2. Tabelle (USER) schreiben...
               IOR2=SQL(2; '#INSERTALL %TAB.TABNAME'; UDSN; 'TAB')
               if IOR2
                  {
                  RECANZ2 = RECANZ2 + 1   $ Schreibzhler hochsetzen
                  else
                     {
                     TABCREATE_OK = 0
                     error
                        {
                        "~a089f Fehler beim Schreiben in USER-Tabelle"
                        }
                     }
                  }


               $ nchten Datensatz in Tabelle 1 suchen
               IOR1=SQL(1; '#NEXT'; DSN)
               if IOR1
                  {
                  TAB.SKEY = TAB.SKEY
                  RECANZ1 = RECANZ1 + 1      $ Lesezhler hochsetzen
                  K = K + 1
                  =RUNNING(K)
                  else
                     {
                     IOR1 = 0
                     }
                  }
               }
            }
         }
      }
   }

